const updater = require('.')
const repo = 'some-owner/some-repo'
const os = require('os')
const tmpdir = os.tmpdir()
const fs = require('fs')
const path = require('path')
const electron = {
  app: {
    getVersion: () => { return '1.2.3' },
    isReady: () => { return true },
    on: (eventName) => { /* no-op */ },
    getAppPath: () => { return tmpdir }
  },
  autoUpdater: {
    checkForUpdates: () => { /* no-op */ },
    on: (eventName) => { /* no-op */ },
    setFeedURL: () => { /* no-op */ }
  },
  dialog: {
    showMessageBox: () => { /* no-op */ }
  }
}

let autoUpdater = electron.autoUpdater

test('exports a function', () => {
  expect(typeof updater).toBe('function')
})

describe('logger', () => {
  test('must be an object defining a `log` function', () => {
    expect(() => {
      updater({electron, autoUpdater, logger: 'yep'})
    }).toThrowError('logger.info is not a function')
  })
})

describe('updateInterval', () => {
  test('must be 5 minutes or more', () => {
    expect(() => {
      updater({electron, autoUpdater, updateInterval: '20 seconds'})
    }).toThrowError('updateInterval must be `5 minutes` or more')
  })

  test('must be a string', () => {
    expect(() => {
      updater({electron, autoUpdater, updateInterval: 3000})
    }).toThrowError('updateInterval must be a human-friendly string interval like `20 minutes`')
  })
})
